package de.mlessmann.certassist.web;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import org.springframework.data.domain.Page;

import java.util.List;

public interface DocumentedPage<T> extends Page<T> {

    @Override
    @JsonProperty
    @Schema(description = "The content of the paginated response. See nested type for more information.")
    List<T> getContent();

    @Override
    @JsonProperty("size")
    @Schema(description = "How many items there are in this current page.")
    int getNumberOfElements();

    @Override
    @JsonProperty
    @Schema(description = "How many pages are currently available in total.")
    int getTotalPages();

    static <T> DocumentedPage<T> of(Page<T> page) {
        return (DocumentedPage<T>) page;
    }
}
